/* XLanguage - the eXtensible Language
 * Copyright (C) 2001 Patrick Deschenes
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/* These files are distributed at http://www.freesoftware.fsf.org/xlang/
 */

#include <xlfield.h>

XLField*
xl_field_new (XString* p_name, XLType* p_type)
{
  XLField *self;
  
  self = x_new (XLField);
  x_object_init_object (X_OBJECT (self), xl_field_destroy);
  
  self->type = x_addref (XLType, p_type);
  self->name = x_addref (XString, p_name);
  self->index = 0;
  
  return self;
}

xvoid
xl_field_destroy (XObject* self)
{
  x_unref (XL_FIELD (self)->type);
  x_unref (XL_FIELD (self)->name);

  x_destroy (self);
}

